<?php /* -*- PHP -*- */

/* configuration file */
define (CONFIGFILE, "config.inc.php");
if (!defined ("_UNIT_TEST_")) require_once (CONFIGFILE);
if (!defined ("DEPOSIT")) define (DEPOSIT, "");
if (!defined ("HASH")) define (HASH, "");

/* XML header */
Header("content-type: application/xml");

/* default return values */
$stat = -1;
$content = "";

/* check for action */
if (array_key_exists ("action", $_POST)) {

    /* get key from request and create filename */
    $key = array_key_exists ("key", $_POST) ? $_POST["key"] : "";
    if ($key) {
        $name = DEPOSIT . "/" . urlencode ($key) . ".csv";

        /* select action */
        switch ($_POST["action"]) {
        case "load":

            /* open file and  read it */
            $data = file_get_contents ($name);
            if ($data !== false) {
                $content = "<data><![CDATA[" . base64_encode ($data) . "]]></data>";
                $stat = 0;
            }
            break;

        case "save":

            /* get data from request */
            if (!array_key_exists ("data", $_POST))
                break;
            $data = base64_decode ($_POST["data"]);

            /* open file for writing */
            $fd = fopen ($name, "w");
            if ($fd) {

                /* write file */
                $stat = 0;
                for ($written = 0; $written < strlen ($data); $written += $fwrite) {
                    $fwrite = fwrite ($fd, substr ($data, $written));
                    if ($fwrite === false) {
                        $stat = 1;
                        break;
                    }
                }
                fclose ($fd);
            }
            break;

        }
    } else {

        /* select action */
        switch ($_POST["action"]) {
        case "mng_get":
            $content = "<deposit><![CDATA[" . DEPOSIT . "]]></deposit>" . "<hash><![CDATA[" . HASH . "]]></hash>";
            $stat = 0;
            break;

        case "mng_list":
            if (file_exists (DEPOSIT) && is_dir (DEPOSIT) && ($dh = opendir (DEPOSIT))) {
                while (($f = readdir ($dh)) != false) {
                    if ((strcmp ($f, ".") == 0) || (strcmp ($f, "..") == 0) ||
                        (!is_file (DEPOSIT . "/$f")) || (!(strcmp (substr ($f, -4), ".csv") == 0)))
                        continue;
                    $size = filesize (DEPOSIT . "/" . $f);
                    $content .= "<db><name>$f</name><size>$size</size></db>";
                }
                closedir ($dh);
                $stat = (strlen ($content) == 0) ? 1 : 0;
            }
            break;

        case "mng_set":
            $deposit = (array_key_exists ("deposit", $_POST)) ? $_POST["deposit"] : "";
            $hash = (array_key_exists ("hash", $_POST)) ? $_POST["hash"] : "";

            if ((strlen ($deposit) == 0) && (strlen ($hash) == 0))
                break;

            /* Update config file */
            $fd = fopen (CONFIGFILE, "w");
            if ($fd) {
                fprintf ($fd,
                         "<?php /* -*- PHP -*- */\n" .
                         "/* DB storage */\n" .
                         "define ('DEPOSIT', '%s');\n".
                         "/* Admin pass phrase */\n" .
                         "define ('HASH', '%s');\n".
                         "?>",
                         (strlen ($deposit) > 0) ? $deposit : DEPOSIT,
                         (strlen ($hash) > 0) ? $hash : HASH);
                fclose ($fd);
                $stat = 0;
            }
            break;

        }
    }

} else if (array_key_exists ("data", $_POST)) {

    /* create temporary file name */
    $name = tempnam("/tmp", "crg-");
    $logname = $name . ".log";
    $pdfname = $name . ".pdf";
    $texname = $name . ".tex";

    /* create temporary tex file */
    $fd = fopen ($texname, "w");
    if ($fd) {
        fwrite ($fd, base64_decode ($_POST["data"]));
        fclose ($fd);

        /* texify refcard */
        exec ("pdftex -interaction=nonstopmode -output-directory=/tmp " . $texname, $msg, $stat);

        /* read pdf file */
        if (file_exists ($pdfname)) {
            $fd = fopen ($pdfname, "r");
            if ($fd) {
                $data = fread ($fd, filesize ($pdfname));
                $content = "<data><![CDATA[" . base64_encode ($data) . "]]></data>";
                fclose ($fd);
            }
        }

        /* clean all files */
        unlink ($name);
        unlink ($texname);
        if (file_exists ($logname)) unlink ($logname);
        if (file_exists ($pdfname)) unlink ($pdfname);
    }
}

/* create XML string */
echo "<xml><message>$content<stat>" . $stat . "</stat></message></xml>";
